//AlignerSurInterieur_207f.js
// 26.01.09 / Hans Haesler, Chtelard 52, CH-1018 Lausanne
//Ce script sert  modifier l'alignement des contours de 
//"centrer"  "intrieur" et  adapter la position des objets


// tester si un document est ouvert
if (app.documents.length == 0) {
	alert ("Il n'y a pas de document ouvert.", "Attention");
	exit();
}

curDoc = app.documents[0];

// slectionner le point de rfrence au centre
var trp = app.layoutWindows[0].transformReferencePoint;
if (trp != 1095656308) {
	app.layoutWindows[0].transformReferencePoint = 1095656308;
}

// tester la slection
var curSel = app.selection;
var nSel = curSel.length;

// si'il n'y a pas de slection...
if (nSel == 0) {
	var groupList = new Array ();
	// ...mmoriser toutes les groupes
	var allGroups = curDoc.groups;
	for (var i=0; i<allGroups.length; i++) {
		if (allGroups[i].locked == true) {
			try {
				allGroups[i].locked == false;
				groupList.push(allGroups[i]);
			}
			catch (e) {
				alert ("Il faut liberer les blocs verrouills.", "Stop");
				reStore(trp);
				exit();
			}
		}
	}
	nLocks = groupList.length;
	var allFrames = app.documents[0].allPageItems;
	var nFrames = allFrames.length; 
	modAll(allFrames, nFrames);
	if (nLocks > 0) {
		for (var k=0; k<nLocks; k++) {
			try {
				groupList[k].locked = true;
			}
			catch (e) {
				alert ("Il faut liberer les blocs verrouills.", "Stop");
				reStore(trp);
				exit();
			}
		}
	}
}

// sinon seulement ceux de la slection
else {
	modSel(curSel, nSel);
}

// appeler la fonction pour rtablir le point de rfrence 
reStore(trp);

if (nSel == 0) {
	alert ("C'est fait.");
}

function modAll(allFrames, nFrames) {
	var unLock;
	// mmoriser le verrouillage des calques et les dverrouiller (si ncessaire)
	var allLayers = curDoc.layers;
	var nLayers = allLayers.length;
	var layerLocks = new Array ();
	for (var i=0; i<nLayers; i++) {
		if (allLayers[i].locked == true) {
			allLayers[i].locked = false;
			layerLocks.push(true);
		}
		else {
			layerLocks.push(false);
		}
	}
	for (var i=0; i<nFrames; i++) {
		// mettre la rfrence du bloc actuel dans la variable 'curFrame'
		var curFrame = allFrames[i];
		// mmoriser le type du bloc
		var frameType = curFrame.constructor.name;
		// la variable 'allFrames' contient galement les groupes, 
		// mais leurs lments se retrouvent encore une fois dans 
		// la liste. On peut donc exclure les objets "groupe", afin 
		// d'viter un message d'erreur quand l'paisseur des contours 
		// des blocs d'un groupe ne sont pas identiques
		if (nLocks == 0) {
			if (frameType != "Group") {
				unLock = false;
				if (curFrame.locked == true) {
					unLock = true;
					try {
						curFrame.locked = false;
					}
					catch (e) {
						alert ("Il faut liberer les blocs verrouills.", "Stop");
						reStore(trp);
						exit();
					}
				}
				modFrame(curFrame);
				if (unLock == true) {
					try {
						curFrame.locked = true;
					}
					catch (e) {
					}
				}
			}
		}
		else {
			if (frameType == "Group") {
				unLock = false;
				if (curFrame.locked == true) {
					unLock = true;
					try {
						curFrame.locked = false;
					}
					catch (e) {
						alert ("Il faut liberer les blocs verrouills.", "Stop");
						reStore(trp);
						exit();
					}
				}
			}
			if (frameType != "Group") {
				unLock = false;
				if (curFrame.locked == true) {
					unLock = true;
					try {
						curFrame.locked = false;
					}
					catch (e) {
						alert ("Il faut liberer les blocs verrouills.", "Stop");
						reStore(trp);
						exit();
					}
				}
				modFrame(curFrame);
				if (unLock == true) {
					try {
						curFrame.locked = true;
					}
					catch (e) {
					}
				}
			}
		}
	}
	// rtablir le verrouillage des calques (si ncessaire)
	for (var i=0; i<nLayers; i++) {
		allLayers[i].locked = layerLocks[i];
	}
}

function modSel(curSel, nSel) {
	var actType;
	var actFrame;
	var curFrame;
	var curType;
	var topGroup;
	var unLock;
	var unLockParent;
	for (var i=0; i<nSel; i++) {
		// mettre la rfrence du bloc actuel dans la variable 'curFrame'
		curFrame = curSel[i];
		// mmoriser le type du bloc
		curType = curFrame.constructor.name;
		// les objets qui ne sont pas des groupes sont passs  la fonction 
		// 'modFrame', sinon  la fonction 'modGroup'
		if (curType != "Group") {
			// si le bloc n'est pas slectionn directement, relever la rfrence 
			// (= pour faire plaisir  l'utilisateur :-)
			if (curType == "InsertionPoint" || curType == "Character" || curType == "Text" 
				|| curType == "Word" || curType == "Line" || curType == "Paragraph" 
				|| curType == "TextStyleRange" || curType == "TextColumn") {
				curFrame = curFrame.parent.textFrames.item(0);
			}
			// exclure les filets
			if (curType != "GraphicLine") {
				unLock = false;
				unLockParent = false;
				if (curFrame.locked == true) {
					unLock = true;
					try {
						curFrame.locked = false;
					}
					catch (e) {
						unLockParent = true;
						actType = "Group";
						actFrame = curFrame.parent;
						while (actType == "Group") {
							actType = actFrame.constructor.name;
							if (actType == "Group") {
								topGroup = actFrame;
							}
							try {
								actFrame.parent.locked = false;
							}
							catch (e) {
							}
							actFrame = actFrame.parent;
						}
					}
				}
				modFrame(curFrame);
				if (unLockParent == true) {
					try {
						topGroup.locked = true;
					}
					catch (e) {
					}
				}
				else if (unLock == true) {
					try {
						curFrame.locked = true;
					}
					catch (e) {
					}
				}
			}
		}
		else {
			var unLock = false;
			if (curFrame.locked == true) {
				unLock = true;
				try {
					curFrame.locked = false;
				}
				catch (e) {
					alert ("Il faut liberer les blocs verrouills.", "Stop");
					reStore(trp);
					exit();
				}
			}
			modGroup(curFrame);
			if (unLock == true) {
				try {
					curFrame.locked = true;
				}
				catch (e) {
				}
			}
		}
	}
}

function modGroup(curGroup) {
	var allFrames = curGroup.allPageItems;
	var nFrames = allFrames.length;
	var unLock;
	for (var i=0; i<nFrames; i++) {
		curFrame = allFrames[i];
		curType = curFrame.constructor.name;
		if (curType != "Group") {
			if (curType != "GraphicLine") {
				unLock = false;
				if (curFrame.locked == true) {
					unLock = true;
					try {
						curFrame.locked = false;
					}
					catch (e) {
						alert ("Il faut liberer les blocs verrouills.", "Stop");
						reStore(trp);
						exit();
					}
				}
				modFrame(curFrame);
				if (unLock == true) {
					try {
						curFrame.locked = true;
					}
					catch (e) {
					}
				}
			}
		}
	}
}

function modFrame(curFrame) {
	// ne traiter que des blocs dont l'alignement est "centrer"
	if (curFrame.strokeAlignment == StrokeAlignment.centerAlignment) {
		try {
			// Mettre les angles de rotation et/ou de dformation  zro (si ncessaire)
			var curRot = curFrame.rotationAngle;
			if (curRot != 0) {
				curFrame.rotationAngle = 0;
			}
			var curShear = curFrame.shearAngle;
			if (curShear != 0) {
				curFrame.shearAngle = 0;
			}
			// appliquer les nouvelles valeurs des bords
			curFrame.geometricBounds = curFrame.visibleBounds;
			// modifier l'alignement  "sur l'intrieur" 
			curFrame.strokeAlignment = StrokeAlignment.insideAlignment;
			// rtablir les angles de rotation et/ou de dformation
			if (curRot != 0) {
				curFrame.rotationAngle = curRot;
			}
			if (curShear != 0) {
				curFrame.shearAngle = curShear;
			}
		}
		catch (e) {
			alert ("Il faut liberer les blocs verrouills.", "Stop");
			reStore(trp);
			exit();
		}
	}
}

// rtablir le point de rfrence (si ncessaire)
function reStore(trp) {
	if (trp != 1095656308) {
		app.layoutWindows[0].transformReferencePoint = trp;
	}
}